'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'                                                                               
'                                          
'                                          
'                                      
'                                  
'                                 
'                                       
'                               
'
'-                                                                           =
'=-     A QB RPG by Sam Thursfield (sam.thursfield@btinternet.com), 2000    =-
'-                                                                           =
'
'Email me at sam.thursfield@btinternet.com, see my site at eps.50megs.com,
'play the MUD at www.medievia.com, look out for my font, VFont3, download
'DarkDread's Mysterious Song from welcome.to/DarknessEthereal, follow the
'progress of DarkAges II: Taftkraftengel (sp?) and download DarkAges I: The
'Continents from www.tcnj.edu/~hoopman2,and go to the ever-improving
'www.neozones.com. Also go to the ABC site at www.basicguru.com/abc.
'
'This is the source code. Read ARADINA.DOC for the manual.
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

DEFINT A-Z

'$INCLUDE: 'AraLib.bi'

'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'                        - Sub/Function Declarations -
'                        =-=-=-=-=-=-=-=-=-=-=-=-=-=-=

DECLARE FUNCTION AraKey (KeyCode)
DECLARE FUNCTION Trim$ (I)
DECLARE FUNCTION PackOffset& (Archive$, Filename$, Length&)
DECLARE FUNCTION VLen (Text$, FontArray())
DECLARE SUB CheckKeys ()
DECLARE SUB DrawMap (AddX, AddY)
DECLARE SUB DrawPlayer ()
DECLARE SUB DrawScreen (AddX, AddY)
DECLARE SUB DrawStatus ()
DECLARE SUB FLoad (FileNum, FileOffset&, DataLength&, DestSeg, DestOff)
DECLARE SUB Init ()
DECLARE SUB LoadMap (MapNum)
DECLARE SUB LoadPak ()
DECLARE SUB Main ()
DECLARE SUB MoveDown ()
DECLARE SUB MoveLeft ()
DECLARE SUB MoveRight ()
DECLARE SUB MoveUp ()
DECLARE SUB Quit ()
DECLARE SUB SpriteDraw (SpriteToDraw, PosX, PosY)
DECLARE SUB Start ()
DECLARE SUB TileDraw (Tile, PosX, PosY)
DECLARE SUB UpFrame (Direction)
DECLARE SUB VFont (BufferSeg, BufferOff, XPos, YPos, Text$, Col, BCol, Style, FontArray())
DECLARE SUB VLoadFont (File$, Array())

'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'                              - Constants -
'                              =-=-=-=-=-=-=

CONST DebugMode = 0             'If you were thinking this lets you cheat, it
                                'doesn't. All it does is run without the
                                'keyboard handler. So there. I put it in for
                                'debugging when I wanted to actually see where
                                'the error was and have a descriptive message,
                                'not just a black screen with "Error 9" written
                                'in the corner.

CONST True = -1                 'These constants should be built in to QB
CONST False = 0                 '(like they are in Turbo Pascal) if you ask
                                'me. So don't ask me.

CONST Up = 0                    'These constants are used in UpFrame, which
CONST Right = 1                 'animates the character. Their use is probably
CONST Down = 2                  'pretty self-explanitory.
CONST Left = 3

CONST Shaded = 1                'These constants are for VFont3.
CONST Italic = 2
CONST Shadowed = 4
CONST Centered = -32767

CONST Version = "0.040a"        'This is the version number. (Obviously).

'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'                                 = Types =
'                                 -=-=-=-=-

TYPE PakHeader                  'This is the header of the Pakfiles:
    Version AS STRING * 5       'the version of the packfile (1.0), and
    Total AS STRING * 3         'the total number of files in the archive.
END TYPE

'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'                              - Variables -
'                              =-=-=-=-=-=-=

DIM SHARED MapXSize             'Map data:
DIM SHARED MapYSize             'map X size and Y size, and
DIM SHARED Map(-1 TO 32, -1 TO 31)  'the actual map array: the tile number
                                'and whether it is solid or not (if there's
                                'a - before it it is solid)).

DIM SHARED PlayerX              'These are all data on the player:
DIM SHARED PlayerY              'player X and Y position,
DIM SHARED PlayerScreenX        'player X and Y position on the screen (this
DIM SHARED PlayerScreenY        'is for the actual player sprite), and
DIM SHARED PlayerTileX          'the tile the player sprite is actually
DIM SHARED PlayerTileY          'standing on.
DIM SHARED PlayerFrame          'Animation frame
DIM SHARED PlayerHP             'This is the player's health and magic points.
DIM SHARED PlayerMP

DIM SHARED TileData(649)        'The current tile sets, and
DIM SHARED SpriteData(2328)     'the sprite images.

DIM SHARED Buffer(31999)        'This is the double buffer (AKA memory eater).

DIM SHARED Pal AS STRING * 768  'This holds the palette.

DIM SHARED Font(255, 16)        'This is the font for VFont3.

'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'                              - Main Code -
'                              =-=-=-=-=-=-=

IF NOT DebugMode THEN           'If the keyboard handler's in place (so we're
    ON ERROR GOTO CockUp        'not in debug mode) then when QB breaks for an
END IF                          'error the keyboard won't work, so we make a
                                'custom error handler to unload the keyboard
                                'handler in the event of an error occuring.

Init                            'Initialise the game.
Start                           'This runs the main menu.

'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'                            - Error Handler -
'                            =-=-=-=-=-=-=-=-=

CockUp:                         'This is the error handler.

IF NOT DebugMode THEN           'We shouldn't really need the DebugMode check
    Nothing = AraKey(-2)        'on this line, because the purpose of
END IF                          'DebugMode is for me to use the real error
                                'handler (which shows where the error is and
                                'gives a real message, not just a number), so
                                'if we get to here the keyboard handler must
                                'be in place. I have it here just in case. (It
                                'uninstalls the keyboard handler, if you were
                                'wondering what it does).

SCREEN 0: WIDTH 80, 25          'Now we go into text mode.
                             
PRINT "Error "; ERR             'Say what the error number is,

END                             'and end.

REM $DYNAMIC
FUNCTION AraKey (KeyCode)       'This is the keyboard handler.

STATIC KBAsm()                  'KBAsm is the keyboard handler machine code.
STATIC KBMatrix()               'KBMatrix is the status of the each key.
STATIC ASMLoaded                'ASMLoaded is true if the code is in memory.
STATIC InterruptHooked          'InterruptHooked is true if the code is
                                'installed as the keyboard interrupt.

IF ASMLoaded = False THEN       'If the ASM isn't loaded, load it.

    DIM KBAsm(128)              'Dimension the arrays to the right size.
    DIM KBMatrix(128)

    Code$ = ""                  'Initialise the code.
    Code$ = Code$ + "E91D00E93C00000000000000000000000000000000000000000000000000"
    Code$ = Code$ + "00001E31C08ED8BE24000E07BF1400FCA5A58CC38EC0BF2400B85600FAAB"
    Code$ = Code$ + "89D8ABFB1FCB1E31C08EC0BF2400BE14000E1FFCFAA5A5FB1FCBFB9C5053"
    Code$ = Code$ + "51521E560657E460B401A8807404B400247FD0E088C3B700B0002E031E12"
    Code$ = Code$ + "002E8E1E100086E08907E4610C82E661247FE661B020E6205F075E1F5A59"
    Code$ = Code$ + "5B589DCF"

    DEF SEG = VARSEG(KBAsm(0))  'Set the segment to the asm code array

        FOR I = 0 TO 155        'Load the Code (hey that rhymes...)
            HexCode = VAL("&H" + MID$(Code$, I * 2 + 1, 2))
            POKE VARPTR(KBAsm(0)) + I, HexCode
        NEXT I

        Offset& = 16            'Now we set up the code.

        KBSeg& = VARSEG(KBMatrix(0))            'We want to tell the code the
        LowByte& = KBSeg& AND 255               'segment of KBMatrix, so we
        HighByte& = (KBSeg& AND &HFF00) \ 256   'poke the low byte and the
        POKE Offset&, LowByte&                  'high byte of the segment into
        POKE Offset& + 1, HighByte&             'the code at Offset& (where it
                                                'expects it).
     
        Offset& = Offset& + 2                   'Move on two bytes in the code.

        KBOff& = VARPTR(KBMatrix(0))            'Now we have to tell the code
        LowByte& = KBOff& AND 255               'where the offset of KBMatrix
        HighByte& = (KBOff& AND &HFF00) \ 256   'is, and we do it the same way
        POKE Offset&, LowByte&                  'as for the segment, but two
        POKE Offset& + 1, HighByte&             'bytes further on.

        Offset& = Offset& + 2                   'Move on two bytes again.

    DEF SEG

    ASMLoaded = True            'Set this to true so we don't load the code
                                'a second time.
END IF

SELECT CASE KeyCode             'Now we see what to do:

    CASE -1                     'This means we install the handler.

        IF InterruptHooked = False THEN 'If it's not already installed we
            DEF SEG = VARSEG(KBAsm(0))  'call the installing section of the
                CALL ABSOLUTE(0)        'code (offset 0). Then we set
            DEF SEG                     'InterruptHooked to true so we don't
            InterruptHooked = True      'install it twice (which would be a
        END IF                          'bit stupid).

    CASE -2                     'This means we remove the handler.

        IF InterruptHooked = True THEN  'If it is installed, we call the
            DEF SEG = VARSEG(KBAsm(0))  'uninstalling section of the code
                CALL ABSOLUTE(3)        '(offset 3). Then we set
            DEF SEG                     'InterruptHooked to false so we don't
            InterruptHooked = False     'try to remove it again (it's a bit
        END IF                          'dippy to remove it twice &^).

    CASE 1 TO 128               'This means we check the state of a key.

        AraKey = KBMatrix(KeyCode)      'We look up the key in KBMatrix. If it
                                        'is pressed, AraKey will be -1. If
                                        'not, it will be 0.

    CASE ELSE                   'This means the user is an idiot.

        AraKey = RND * 40               'Return a random number to the user
                                        'for punishment.
END SELECT

END FUNCTION

SUB CheckKeys                   'This checks the keyboard.
    
IF NOT DebugMode THEN           'If the keyboard handler's in, we use this:

    IF AraKey(1) THEN Quit      'If escape is pressed, quit the game.

    IF AraKey(72) THEN          'If up is pressed, we move up.
        MoveUp
    END IF

    IF AraKey(75) THEN          'If left is pressed, move left.
        MoveLeft
    END IF

    IF AraKey(77) THEN          'If right is pressed, move right.
        MoveRight
    END IF

    IF AraKey(80) THEN          'If down is pressed, move down.
        MoveDown
    END IF

ELSE                            'If we are in DebugMode just check for escape
                                'and down.

    I$ = INKEY$                 'Get the pressed key in I$.

    IF I$ = CHR$(27) THEN Quit  'If it is escape then quit.

    IF I$ = CHR$(0) + "H" THEN MoveUp

    IF I$ = CHR$(0) + "P" THEN MoveDown

END IF

END SUB

SUB DrawMap (AddX, AddY)        'Draw the map.

FOR X = -1 TO 20                'Draw all the tiles on screen (and some off
    FOR Y = -1 TO 13            'screen too)
        TileDraw Map(X + PlayerX, Y + PlayerY), X * 16 + AddX, Y * 16 + AddY
    NEXT
NEXT

END SUB

SUB DrawPlayer                  'Draw the player.

SpriteDraw PlayerFrame, PlayerScreenX, PlayerScreenY

END SUB

SUB DrawScreen (AddX, AddY)     'This redraws the screen.

REDIM Buffer(0)                 'Clear the screen by setting all the elements
REDIM Buffer(31999)             'in the buffer to 0 (clever, huh?)

DrawMap AddX, AddY              'Draw the map, the player, then the status
DrawPlayer                      'bar.
DrawStatus

WAIT &H3DA, 8                   'Wait for vertical retrace and then flip the
WAIT &H3DA, 8, 8                'buffer.

AraCopyBuffer VARSEG(Buffer(0)), VARPTR(Buffer(0)), &HA000, 0

END SUB

SUB DrawStatus                  'Draw the status bar.

AraBox3D VARSEG(Buffer(0)), VARPTR(Buffer(0)), 0, 0, 319, 11, 77, 76, 75, 74, 73

StatusString$ = "HP: " + Trim$(PlayerHP) + "  MP: " + Trim$(PlayerMP) + "  TL: " + Trim$(Map(PlayerTileX, PlayerTileY)) + "  X: " + Trim$(PlayerTileX) + "  Y:" + Trim$(PlayerTileY)
                                                          
VFont VARSEG(Buffer(0)), VARPTR(Buffer(0)), 2, 2, StatusString$, 80, 0, Shaded, Font()

END SUB

SUB FLoad (FileNum, FileOffset&, DataLength&, DestSeg, DestOff) 'This loads files from the pakfile.

RemBytes& = DataLength&         'RemBytes has the number of remaining bytes to
                                'get from the file.
BufferSize = 32766              'Buffersize is the maximum size of the buffer.

DEF SEG = DestSeg               'Set up the memory so we're at the segment and
    Ptr& = DestOff              'offset (in Ptr&) of the destination array.

    LeftBytes& = RemBytes& MOD BufferSize   'Leftbytes is the number of bytes
                                            'left over from the buffer.

    SEEK #FileNum, FileOffset&  'Seek the offset in the file.

    IF (LeftBytes& < RemBytes&) THEN    'If the buffer is smaller than the
                                        'data to load, then do this:

        FOR QuickLoad = 1 TO (DataLength& - LeftBytes&) / BufferSize

            Buffer$ = SPACE$(BufferSize)    'Set the buffer and get it from
            GET #1, , Buffer$               'the file. Then, go through the
            FOR X = 1 TO BufferSize         'buffer and poke the contents in
                POKE Ptr&, ASC(MID$(Buffer$, X, 1)) 'to memory, a byte at a
                Ptr& = Ptr& + 1             'time.
            NEXT

            Buffer$ = ""                        'Then, reset the buffer and
            RemBytes& = RemBytes& - BufferSize  'decrement the number of
                                                'remaining bytes.
        NEXT                            'Loop again.

    END IF

    IF (LeftBytes& > 0) THEN            'If there is more data,
        Buffer$ = SPACE$(LeftBytes&)    'get it all in the buffer and then
        GET #1, , Buffer$               'poke it all into memory.
        FOR X = 1 TO LeftBytes&
            POKE Ptr&, ASC(MID$(Buffer$, X, 1))
            Ptr& = Ptr& + 1
        NEXT
        Buffer$ = ""
    END IF

DEF SEG

END SUB

SUB Init                        'This sub initialises everything.

SCREEN 0                        'Make sure we're in text mode, and clear the
WIDTH 80, 25                    'screen anyway.

LOCATE 1, 1                     'This prints the fancy title bar background:
COLOR 4, 0                      'First we locate at the top of the screen
PRINT "";              '(position 1, 1) and then we print the fancy
PRINT STRING$(62, 219);         'title there in the colours red on black
PRINT ""               '(4, 0).

LOCATE 1, 27                    'Now we centre the title on it (colours white
COLOR 15, 4                     'on red) with a precalculated X position.
PRINT "Aradina " + Version + " Initialisation"

PRINT                           'Put a blank line (obviously).

COLOR 14, 0                     'Headings are in yellow, and this one
PRINT " Initialising:"         'initialises stuff (like the keyboard handler)
                                'and, sensibly, is called "Initialising".

    COLOR 7                     'Subheadings are in grey.

    PRINT "     Initialising keyboard handler..."; 'Guess what...this
                                                    'initialises the keyboard
                                                    'handler...

        IF NOT DebugMode THEN   '...but only if we're not in debug mode. If we
            Nothing = AraKey(-1)'aren't, we initialise the keyboard handler
            PRINT "done"        'and install it as the keyboard interrupt.
        ELSE                    'Otherwise, we don't initialise it.
            PRINT "no I'm not, because we're in debug mode here."
        END IF

    PRINT "     Initialising variables...";

        PlayerHP = 12           'Sets the player health and magic points to
        PlayerMP = 5            'their starting numbers.

    PRINT "done"

COLOR 14                        'This bit loads the files: the Pakfile to be
PRINT " Loading files:"        'exact.

    COLOR 7                     'Grey headings.

    PRINT "     Loading data from pakfile..."; 'Load the sprites from
        LoadPak                                 'the Pakfile.
    PRINT "done"

    PRINT "     Loading font...";              'Load the font (not from the
        VLoadFont "ARADINA.FNT", Font()         'Pakfile, because I couldn't
    PRINT "done"                                'get it to.)

SCREEN 13                       'Maybe next time we'll be in SVGA...

AraPalSet VARSEG(Pal), VARPTR(Pal)  'Set the right palette.

END SUB

SUB LoadMap (MapNum)                    'Loads the map.

OPEN "ARADINA.PAK" FOR BINARY AS #1     'Open the pakfile and get the offset
                                        'of the map to be loaded in Offset&.
    Offset& = PackOffset&("ARADINA.PAK", "ARA" + Trim$(MapNum) + ".MP2", Length&)

    SEEK #1, Offset&                    'Go to the map in the pakfile and get
    GET #1, , MapXSize                  'all the map data from it.
    GET #1, , MapYSize
    GET #1, , PlayerX
    GET #1, , PlayerY
    GET #1, , PlayerScreenX
    GET #1, , PlayerScreenY
    GET #1, , NumUsedTileSets
    DIM UsedTileSet(1 TO NumUsedTileSets)
    FOR I = 1 TO NumUsedTileSets
        GET #1, , UsedTileSet(I)
    NEXT I
    FOR X = 1 TO MapXSize
        FOR Y = 1 TO MapYSize
            GET #1, , Map(Y, X)
        NEXT
    NEXT

    CurOffset = 0                       'Now we load the tilesets:
    FOR I = 1 TO NumUsedTileSets        'For each set, get the offset and seek
        Offset& = PackOffset&("ARADINA.PAK", "ARA" + Trim$(UsedTileSet(I)) + ".TL2", Length&)
        SEEK #1, Offset&                'it in the pakfile, and FLoad it.
        FLoad 1, Offset&, Length&, VARSEG(TileData(CurOffset)), VARPTR(TileData(CurOffset))
        CurOffset = CurOffset + Length& \ 2
    NEXT I
   
    Offset& = PackOffset&("ARADINA.PAK", "ARA1.SP2", Length&)   'Now load the
    SEEK #1, Offset&                                            'sprites.
    FLoad 1, Offset&, Length&, VARSEG(SpriteData(0)), VARPTR(SpriteData(0))

CLOSE #1

END SUB

SUB LoadPak                     'This loads data from the Pak file.
      
OPEN "ARADINA.PAK" FOR BINARY AS #1 'Open the file and read in the palette.

    Offset& = PackOffset&("ARADINA.PAK", "ARADINA.PAL", Length&)
    SEEK #1, Offset&
    GET #1, , Pal
   
CLOSE #1                        'Er...that seems to be all.

END SUB

SUB Main                        'This is the heart of the program.

LoadMap 1                       'Load the first map.

DO                              'Main loop:
    DrawScreen 0, 0             'Draw the screen,
    CheckKeys                   'check the keyboard, and
LOOP                            'loop again.

END SUB

SUB MoveDown                    'Move the character down a tile.

IF PlayerScreenY < 83 THEN      'If he's on the top edge, then just move the
                                'character down one tile and leave the screen
    FOR I = 1 TO 16 STEP 2      'where it is.
        UpFrame Down
        PlayerScreenY = PlayerScreenY + 2
        DrawScreen 0, 0
    NEXT

    PlayerTileY = PlayerScreenY \ 16 + 1    'Calculate which tile the actual
                                            'character sprite is on.

ELSE

    IF PlayerY < MapYSize - 12 THEN 'If he's not on the bottom edge, then
                                    'move the screen down a tile, two pixels
        FOR I = 1 TO 16 STEP 2      'at a time.
            UpFrame Down
            DrawScreen 0, -I
        NEXT

        PlayerY = PlayerY + 1       'Move down a tile and calculate the tile
        PlayerTileY = PlayerY + 6   'the player sprite is on.

    ELSE

        IF PlayerScreenY < 175 THEN 'If it's not off the screen, move the
                                    'character sprite down a tile.
            FOR I = 1 TO 16 STEP 2
                UpFrame Down
                PlayerScreenY = PlayerScreenY + 2
                DrawScreen 0, 0
            NEXT
            PlayerTileY = PlayerScreenY \ 16 + MapYSize - 11    'Calculate
                                                                'the new tile
        END IF                                                  'the character
    END IF                                                      'is on.
END IF

END SUB

SUB MoveLeft                    'Move the character left a tile.

IF PlayerScreenX > 145 THEN     'If he's on the right end of the map, then
                                'move the sprite left a tile.
    FOR I = 1 TO 16 STEP 2
        UpFrame Left
        PlayerScreenX = PlayerScreenX - 2
        DrawScreen 0, 0
    NEXT
    PlayerTileX = PlayerScreenX \ 16 + MapXSize - 20    'Calculate the new
                                                        'tile the player is
ELSE                                                    'on

    IF PlayerX > 0 THEN         'If we're not on the top of the map, then
                                'move left a tile.
        FOR I = 1 TO 16 STEP 2
            UpFrame Left
            DrawScreen I, 0
        NEXT

        PlayerX = PlayerX - 1   'Move left a tile and calculate the new tile.
        PlayerTileX = PlayerX + 8

    ELSE

        IF PlayerScreenX > 0 THEN   'If we're not off the top of the screen,
                                    'move left a tile.
            FOR I = 1 TO 16 STEP 2
                UpFrame Left
                PlayerScreenX = PlayerScreenX - 2
                DrawScreen 0, 0
            NEXT

            PlayerTileX = PlayerScreenX \ 16

        END IF
    END IF
END IF

END SUB

SUB MoveRight

IF PlayerScreenX < 145 THEN

    FOR I = 1 TO 16 STEP 2
        UpFrame Right
        PlayerScreenX = PlayerScreenX + 2
        DrawScreen 0, 0
    NEXT

    PlayerTileX = PlayerScreenX \ 16

ELSE

    IF PlayerX < MapXSize - 20 THEN

        FOR I = 1 TO 16 STEP 2
            UpFrame Right
            DrawScreen -I, 0
        NEXT

        PlayerX = PlayerX + 1
        PlayerTileX = PlayerX + 9

    ELSE

        IF PlayerScreenX < 297 THEN

            FOR I = 1 TO 16 STEP 2
                UpFrame Right
                PlayerScreenX = PlayerScreenX + 2
                DrawScreen 0, 0
            NEXT

            PlayerTileX = PlayerScreenX \ 16 + MapXSize - 20

        END IF
    END IF
END IF

END SUB

SUB MoveUp

IF PlayerScreenY > 83 THEN

    FOR I = 1 TO 16 STEP 2
        UpFrame Up
        PlayerScreenY = PlayerScreenY - 2
        DrawScreen 0, 0
    NEXT

    PlayerTileY = PlayerScreenY \ 16 + MapYSize - 11

ELSE

    IF PlayerY > 0 THEN

        FOR I = 1 TO 16 STEP 2
            UpFrame Up
            DrawScreen 0, I
        NEXT

        PlayerY = PlayerY - 1
        PlayerTileY = PlayerY + 6

    ELSE

        IF PlayerScreenY > 0 THEN

            FOR I = 1 TO 16 STEP 2
                UpFrame Up
                PlayerScreenY = PlayerScreenY - 2
                DrawScreen 0, 0
            NEXT

            PlayerTileY = PlayerScreenY \ 16 + 1

        END IF
    END IF
END IF

END SUB

FUNCTION PackOffset& (Archive$, Filename$, Length&) 'This finds the offset of a file in the Pakfile.

DIM Pak AS PakHeader            'Pak is the header.

F1 = FREEFILE                   'F1 is the first free file handle.

OPEN Archive$ FOR BINARY AS #F1 'Open the pakfile as F1.

    DIM Byte AS STRING * 1      'Byte is very useful for stuff like this. If
                                'you didn't learn from before and ask me
                                'again, it should be a type in QB like it is
                                'in PowerBASIC or Turbo Pascal or, well, just
                                'about any other programming language.
    DIM File AS STRING * 12     'Ah yes...holds a file name
    DIM FileLen AS STRING * 12  'and a file length

    GET #F1, , Pak              'Get the header from the pakfile.

    Offset& = 9                 'Start just past the pakfile header, and set
    CFile = 1                   'the file count as 1.

    DO                          'Do for each file...

        GET #F1, , File         'Get the filename and file length and then
        GET #F1, , FileLen      'move past that data in the pakfile.
        Offset& = Offset& + 24

        IF Filename$ = RTRIM$(File) THEN EXIT DO    'If this is the file we're
                                                    'after, exit do.

        CFile = CFile + 1       'Add to the file count.
     
        Offset& = Offset& + VAL(FileLen)'Increase the offset...
        SEEK #F1, Offset&               'and skip this file.

        IF CFile > VAL(Pak.Total) THEN  'If we're off the end of
            Offset& = -1                'the file the file isn't in
            EXIT DO                     'there so we may as well
        END IF                          'give up

    LOOP                        'Loop again.

CLOSE #F1                       'Close the file.

PackOffset& = Offset&           'Return the offset of the file and the length
Length& = VAL(FileLen)          'of the file.

END FUNCTION

SUB Quit

IF NOT DebugMode THEN           'If we're not in DebugMode then unload the
    Nothing = AraKey(-2)        'keyboard handler.
END IF

SCREEN 0: WIDTH 80, 25

END                             'Finish it off.

END SUB

SUB SpriteDraw (SpriteToDraw, PosX, PosY)

AraPut VARSEG(Buffer(0)), VARPTR(Buffer(0)), VARSEG(SpriteData(194 * SpriteToDraw)), VARPTR(SpriteData(194 * SpriteToDraw)), PosX, PosY

END SUB

REM $STATIC
SUB Start                       'This does the title and menu.

OPEN "ARADINA.PAK" FOR BINARY AS #1 'First, get the title from the Pakfile,
                                    'and load it straight into the buffer.

    TitlePos& = PackOffset&("ARADINA.PAK", "TITLE.BS2", TitleLen&)
    SEEK #1, TitlePos&
    FLoad 1, TitlePos&, TitleLen&, VARSEG(Buffer(0)), VARPTR(Buffer(0))

CLOSE #1

Selection = 1                   'Initialise the selection.

DO                              'Main loop:

    IF AraKey(28) OR AraKey(57) THEN    'If enter or space is pressed, then
         IF Selection = 1 THEN EXIT DO  'if the selection is one, start a new
         IF Selection = 2 THEN EXIT DO  'game, two then load one, three then
         IF Selection = 3 THEN Quit     'quit.
    END IF

    IF AraKey(72) THEN                      'If up is pressed, then move up a
        Selection = Selection - 1           'line and if it's off the top, go
        IF Selection < 1 THEN Selection = 3 'down to the bottom.
        WAIT &H3DA, 8                       'Then wait for vertical retrace
        WAIT &H3DA, 8, 8                    'four times to waste a bit of
        WAIT &H3DA, 8                       'time.
        WAIT &H3DA, 8, 8
        WAIT &H3DA, 8
        WAIT &H3DA, 8, 8
        WAIT &H3DA, 8
        WAIT &H3DA, 8, 8
    END IF

    IF AraKey(80) THEN                      'If down is pressed, then move
        Selection = Selection + 1           'down a line and if it's off the
        IF Selection > 3 THEN Selection = 1 'bottom, go up to the top.
        WAIT &H3DA, 8                       'Then wait for vertical retrace
        WAIT &H3DA, 8, 8                    'four times to waste a bit of
        WAIT &H3DA, 8                       'time.
        WAIT &H3DA, 8, 8
        WAIT &H3DA, 8
        WAIT &H3DA, 8, 8
        WAIT &H3DA, 8
        WAIT &H3DA, 8, 8
    END IF

    VFont VARSEG(Buffer(0)), VARPTR(Buffer(0)), -32767, 124, "New Game", 48 - ((Selection = 1) * 16), 40, Shaded + Shadowed, Font()
    VFont VARSEG(Buffer(0)), VARPTR(Buffer(0)), -32767, 132, "Load Game", 48 - ((Selection = 2) * 16), 40, Shaded + Shadowed, Font()
    VFont VARSEG(Buffer(0)), VARPTR(Buffer(0)), -32767, 140, "Quit", 48 - ((Selection = 3) * 16), 40, Shaded + Shadowed, Font()

    WAIT &H3DA, 8                   'Wait for vertical retrace and then flip
    WAIT &H3DA, 8, 8                'the buffer.
   
    AraCopyBuffer VARSEG(Buffer(0)), VARPTR(Buffer(0)), &HA000, 0

LOOP

DO: LOOP WHILE AraKey(28) OR AraKey(57) 'Make sure the keys aren't still down.

Main                            'Run the main section.

END SUB

REM $DYNAMIC
SUB TileDraw (Tile, PosX, PosY)

IF Tile < 100 THEN
    TileToDraw = Tile
ELSEIF Tile < 200 THEN
    TileToDraw = Tile - 100
END IF

AraPut VARSEG(Buffer(0)), VARPTR(Buffer(0)), VARSEG(TileData(TileToDraw * 130)), VARPTR(TileData(TileToDraw * 130)), PosX, PosY

END SUB

FUNCTION Trim$ (I)

Trim$ = LTRIM$(RTRIM$(STR$(I)))

END FUNCTION

SUB UpFrame (Direction)

STATIC OldFrame

FBase = Direction * 3

IF PlayerFrame < FBase OR PlayerFrame > FBase + 2 THEN
    PlayerFrame = FBase
ELSE
    IF PlayerFrame = FBase THEN
        IF OldFrame = FBase + 1 THEN
            PlayerFrame = FBase + 2
        ELSE
            PlayerFrame = FBase + 1
        END IF
        OldFrame = FBase
    ELSEIF PlayerFrame = FBase + 1 THEN
        OldFrame = FBase + 1
        PlayerFrame = FBase
    ELSEIF PlayerFrame = FBase + 2 THEN
        OldFrame = FBase + 2
        PlayerFrame = FBase
    END IF
END IF

END SUB

SUB VFont (BufferSeg, BufferOff, XPos, YPos, Text$, Col, BCol, Style, FontArray())

IF XPos = -32767 THEN XPos = 160 - VLen(Text$, FontArray()) \ 2

Xx = XPos + 7 - (5 * (Style AND 2))
Yy = YPos

IF Style AND 4 THEN
    VFont BufferSeg, BufferOff, XPos + 1, YPos + 1, Text$, BCol, 0, Style - 4, FontArray()
END IF

FOR Chr = 1 TO LEN(Text$)
    'MemPtr = 8 * ASC(MID$(Text$, Chr, 1)) + &HE
    FOR L = 0 TO 15
        BitPattern = FontArray(ASC(MID$(Text$, Chr, 1)), L + 1)
        IF Style AND 2 THEN
            IF (BitPattern AND 1) THEN AraPSet BufferSeg, BufferOff, Xx + (15 - (L \ 2)), Yy + L, Col - (15 - L) * (Style AND 1)
            IF (BitPattern AND 2) THEN AraPSet BufferSeg, BufferOff, Xx + (15 - (L \ 2)) - 1, Yy + L, Col - (15 - L) * (Style AND 1)
            IF (BitPattern AND 4) THEN AraPSet BufferSeg, BufferOff, Xx + (15 - (L \ 2)) - 2, Yy + L, Col - (15 - L) * (Style AND 1)
            IF (BitPattern AND 8) THEN AraPSet BufferSeg, BufferOff, Xx + (15 - (L \ 2)) - 3, Yy + L, Col - (15 - L) * (Style AND 1)
            IF (BitPattern AND 16) THEN AraPSet BufferSeg, BufferOff, Xx + (15 - (L \ 2)) - 4, Yy + L, Col - (15 - L) * (Style AND 1)
            IF (BitPattern AND 32) THEN AraPSet BufferSeg, BufferOff, Xx + (15 - (L \ 2)) - 5, Yy + L, Col - (15 - L) * (Style AND 1)
            IF (BitPattern AND 64) THEN AraPSet BufferSeg, BufferOff, Xx + (15 - (L \ 2)) - 6, Yy + L, Col - (15 - L) * (Style AND 1)
            IF (BitPattern AND 128) THEN AraPSet BufferSeg, BufferOff, Xx + (15 - (L \ 2)) - 7, Yy + L, Col - (15 - L) * (Style AND 1)
            IF Style AND 8 AND L = 15 THEN LINE (Xx + (15 - (L \ 2)) - 8, Yy + L)-(Xx + (15 - (L \ 2)) - 8 + FontArray(ASC(MID$(Text$, Chr, 1)), 0), Yy + L), Col - (15 - L) * (Style AND 1)
        ELSE
            IF (BitPattern AND 1) THEN AraPSet BufferSeg, BufferOff, Xx, Yy + L, Col - (15 - L) * (Style AND 1)
            IF (BitPattern AND 2) THEN AraPSet BufferSeg, BufferOff, Xx - 1, Yy + L, Col - (15 - L) * (Style AND 1)
            IF (BitPattern AND 4) THEN AraPSet BufferSeg, BufferOff, Xx - 2, Yy + L, Col - (15 - L) * (Style AND 1)
            IF (BitPattern AND 8) THEN AraPSet BufferSeg, BufferOff, Xx - 3, Yy + L, Col - (15 - L) * (Style AND 1)
            IF (BitPattern AND 16) THEN AraPSet BufferSeg, BufferOff, Xx - 4, Yy + L, Col - (15 - L) * (Style AND 1)
            IF (BitPattern AND 32) THEN AraPSet BufferSeg, BufferOff, Xx - 5, Yy + L, Col - (15 - L) * (Style AND 1)
            IF (BitPattern AND 64) THEN AraPSet BufferSeg, BufferOff, Xx - 6, Yy + L, Col - (15 - L) * (Style AND 1)
            IF (BitPattern AND 128) THEN AraPSet BufferSeg, BufferOff, Xx - 7, Yy + L, Col - (15 - L) * (Style AND 1)
            IF Style AND 8 AND L = 15 THEN LINE (Xx - 8, Yy + L)-(Xx - 8 + FontArray(ASC(MID$(Text$, Chr, 1)), 0), Yy + L), Col - (15 - L) * (Style AND 1)
        END IF
    NEXT
    Xx = Xx + FontArray(ASC(MID$(Text$, Chr, 1)), 0)
NEXT

END SUB

FUNCTION VLen (Text$, FontArray())

TempLen = 0
FOR I = 1 TO LEN(Text$)
    TempLen = TempLen + FontArray(ASC(MID$(Text$, I, 1)), 0)
NEXT I
VLen = TempLen

END FUNCTION

SUB VLoadFont (File$, Array())  'Loads a VFont3 font file.
        
DEF SEG = VARSEG(Array(0, 0))
    BLOAD File$, VARPTR(Array(0, 0))
DEF SEG

END SUB

